package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListFirewallGroupsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListFirewallGroupsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListFirewallGroupsLogic {
	return &ListFirewallGroupsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListFirewallGroupsLogic) ListFirewallGroups(req *types.ListFirewallGroupsReq) (resp *types.ListFirewallGroupsResp, err error) {
	// todo: add your logic here and delete this line
	ListFirewallGroupsReq := &openstack.ListFirewallGroupsReq{}
	err = copier.CopyWithOption(ListFirewallGroupsReq, req, copier.Option{Converters: utils.Converters})
	ListFirewallGroupsResp, err := l.svcCtx.OpenstackRpc.ListFirewallGroups(l.ctx, ListFirewallGroupsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ListFirewallGroupsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ListFirewallGroupsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
